
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>App Discovery with Google Play / iVAN</title>

    <meta name="description" content="App Discovery with Google Play App Discovery with Google Play, Part 1: Understanding Topics Tuesday, November 08, 2016 Posted by Malay Haldar, Matt MacMahon, Neha Jha and Raj Arasu, Software Engineers Every month, more than a billion users come to Google Play to download apps for">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">App Discovery with Google Play</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2><a href="https://research.googleblog.com/2016/11/app-discovery-with-google-play-part-1.html" rel="external nofollow noreferrer">App Discovery with Google Play, Part 1: Understanding Topics</a></h2>
<p>Tuesday, November 08, 2016</p>
<p>Posted by Malay Haldar, Matt MacMahon, Neha Jha and Raj Arasu, Software Engineers</p>
<p>Every month, more than a billion users come to Google Play to download apps for their mobile devices. While some are looking for specific apps, like Snapchat, others come with only a broad notion of what they are interested in, like “<i>horror games</i>” or “<i>selfie apps</i>”. These broad searches by topic represent nearly half of the queries in Play Store, so it’s critical to find the most relevant apps. </p>
<p>Searches by topic require more than simply indexing apps by query terms; they require an <i>understanding</i> of the topics associated with an app. Machine learning approaches have been applied to similar problems, but success heavily depends on the number of training examples to learn about a topic. While for some popular topics such as “<i>social networking</i>” we had many labeled apps to learn from, the majority of topics had only a handful of examples. Our challenge was to learn from a very limited number of training examples and scale to millions of apps across thousands of topics, forcing us to adapt our machine learning techniques. </p>
<p>Our initial attempt was to build a <a href="https://en.wikipedia.org/wiki/Deep_learning" rel="external nofollow noreferrer">deep neural network</a> (DNN) trained to predict topics for an app based on words and phrases from the app title and description. For example, if the app description mentioned “<i>frightening</i>”, “<i>very scary</i>”, and “<i>fear</i>” then associate the “<i>horror game</i>” topic with it. However, given the learning capacity of DNNs, it completely “memorized” the topics for the apps in our small training data and failed to generalize to new apps it hadn’t seen before.</p>
<p>To generalize effectively, we needed a much larger dataset to train on, so we turned to how people learn as inspiration. In contrast to DNNs, human beings need much less training data. For example, you would likely need to see very few “<i>horror game</i>” app descriptions before learning how to generalize and associate new apps to that genre. Just by knowing the language describing the apps, people can correctly infer topics from even a few examples.</p>
<p>To emulate this, we tried a very rough approximation of this language-centric learning. We trained a neural network to learn how language was used to describe apps. We built a <a href="https://www.tensorflow.org/versions/r0.8/tutorials/word2vec/index.html#the-skip-gram-model" rel="external nofollow noreferrer">Skip-gram model</a>, where the neural network attempts to predict the words around a given word, for example “<i>share</i>” given “<i>photo</i>”. The neural network encodes its knowledge as vectors of floating point numbers, referred to as <i>embeddings</i>. These embeddings were used to train another model called a <i>classifier</i>, capable of distinguishing which topics applied to an app. We now needed much less training data to learn about app topics, due to the large amount of learning already done with Skip-gram.</p>
<p>While this architecture generalized well for popular topics like “<i>social networking</i>”, we ran into a new problem for more niche topics like “<i>selfie</i>”. The single classifier built to predict all the topics together focused most of its learning on the popular topics, ignoring the errors it made on the less common ones. To solve this problem we built a separate classifier for each topic and tuned them in isolation.</p>
<p>This architecture produced reasonable results, but would still sometimes overgeneralize. For instance, it might associate <i>Facebook</i> with “<i>dating</i>” or <i>Plants vs Zombies</i> with “<i>educational games</i>”. To produce more precise classifiers, we needed higher volume and quality of training data. We treated the system described above as a coarse classifier that pruned down every possible {app, topic} pair, numbering in billions, to a more manageable list of {app, topic} pairs of interest. We built a pipeline to have human raters evaluate the classifier output and fed consensus results back as training data. This process allowed us to bootstrap from our existing system, giving us a path to steadily improve classifier performance.</p>
<p><a href="https://4.bp.blogspot.com/-ysKil48TeE8/WCIPiiLzrzI/AAAAAAAABX8/uYqpeRJ-4fMV40A29eQ-lKdpGlOU1EQgQCLcB/s1600/image00.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzLzQuYnAuYmxvZ3Nwb3QuY29tLy15c0tpbDQ4VGVFOC9XQ0lQaWlMenJ6SS9BQUFBQUFBQUJYOC91WXFwZVJKLTRmTVY0MEEyOWVRLWxLZHBHbE9VMUVRZ1FDTGNCL3M2NDAvaW1hZ2UwMC5wbmc=.jpg"></a></p>
<p>To evaluate {app, topic} pairs by human raters, we asked them questions of the form, “<i>To what extent is topic X related to app Y?</i>” Multiple raters received the same question and independently selected answers on a rating scale to indicate if the topic was “important” for the app, “somewhat related”, or completely “off-topic”. Our initial evaluations showed a high level of disagreement amongst the raters. Diving deeper, we identified several causes of disagreement: vague guidelines for answer selection, insufficient rater training, evaluating broad topics like “<i>computer files</i>” and “<i>game physics</i>” that applied to most apps or games. Tackling these issues led to significant gains in rater agreement. Asking raters to choose an explicit reason for their answer from a curated list further improved reliability. Despite the improvements, we sometimes still have to “agree to disagree” and currently discard answers where raters fail to reach consensus.</p>
<p>These app topic classifiers enable search and discovery features in the <a href="https://play.google.com/store/apps?hl=en" rel="external nofollow noreferrer">Google Play Apps store</a>. The current system helps provide relevant results to our users, but we are constantly exploring new ways to improve the system, through additional signals, architectural improvements and new algorithms. In Part 2 of this series, we will discuss how to personalize the app discovery experience for users.</p>
<p>Acknowledgments<br />
This work was done within the Google Play team in close collaboration with Liadan O'Callaghan, Yuhua Zhu, Mark Taylor and Michael Watson.</p>
<h2><a href="https://research.googleblog.com/2016/12/app-discovery-with-google-play-part-2.html" rel="external nofollow noreferrer">App Discovery with Google Play, Part 2: Personalized Recommendations with Related Apps</a></h2>
<p>Wednesday, December 14, 2016</p>
<p>Posted by Ananth Balashankar &amp; Levent Koc, Software Engineers, and Norberto Guimaraes, Product Manager</p>
<p><i>In <a href="https://research.googleblog.com/2016/11/app-discovery-with-google-play-part-1.html" rel="external nofollow noreferrer">Part 1 of this series</a> on app discovery, we discussed using machine learning to gain a deeper understanding of the topics associated with an app, in order to provide a better search and discovery experience on the <a href="https://play.google.com/store/apps?hl=en" rel="external nofollow noreferrer">Google Play Apps Store</a>. In this post, we discuss a deep learning framework to provide personalized recommendations to users based on their previous app downloads and the context in which they are used. </i></p>
<p>Providing useful and relevant app recommendations to visitors of the <a href="https://play.google.com/store/apps?hl=en" rel="external nofollow noreferrer">Google Play Apps Store</a> is a key goal of our apps discovery team. An <a href="https://research.googleblog.com/2016/11/app-discovery-with-google-play-part-1.html" rel="external nofollow noreferrer">understanding of the topics associated with an app</a>, however, is only one part of creating a system that best serves the user. In order to create a better overall experience, one must also take into account the tastes of the user and provide personalized recommendations. If one didn’t, the “You might also like” recommendation would look the same for everyone! </p>
<p>Discovering these nuances requires both an understanding what an app does, and also the context of the app with respect to the user. For example, to an avid sci-fi gamer, similar game recommendations may be of interest, but if a user installs a fitness app, recommending a health recipe app may be more relevant than five more fitness apps. As users may be more interested in downloading an app or game that complements one they already have installed, we provide recommendations based on app relatedness with each other (“You might also like”), in addition to providing recommendations based on the topic associated with an app (“Similar apps”). <br />
<table>
<tbody>
<tr>
<td><a href="https://3.bp.blogspot.com/-YezY_DnbD04/WFGFJKsVUVI/AAAAAAAABdA/SxGmMuwun6s1wcFujOtTvsFQ11y7iBzCACLcB/s1600/Fig.1.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzLzMuYnAuYmxvZ3Nwb3QuY29tLy1ZZXpZX0RuYkQwNC9XRkdGSktzVlVWSS9BQUFBQUFBQUJkQS9TeEdtTXV3dW42czF3Y0Z1ak90VHZzRlExMXk3aUJ6Q0FDTGNCL3M2NDAvRmlnLjEucG5n.jpg"></a></td>
</tr>
<tr>
<td>Suggestions of similar apps and apps that you also might like shown both before making an install decision (left) and while the current install is in progress (right).</td>
</tr>
</tbody>
</table>
<p>One particularly strong contextual signal is app relatedness, based on previous installs and search query clicks. As an example, a user who has searched for and plays a lot of graphics-heavy games likely has a preference for apps which are also graphically intense rather than apps with simpler graphics. So, when this user installs a car racing game, the “You might also like” suggestions includes apps which relate to the “seed” app (because they are graphically intense racing games) ranked higher than racing apps with simpler graphics. This allows for a finer level of personalization where the characteristics of the apps are matched with the preferences of the user.</p>
<p>To incorporate this app relatedness in our recommendations, we take a two pronged approach: (a) offline candidate generation i.e. the generation of the potential related apps that other users have downloaded, in addition to the app in question, and (b) online personalized re-ranking, where we re-rank these candidates using a personalized ML model.</p>
<p>Offline Candidate Generation<br />
The problem of finding related apps can be formulated as a <a href="https://en.wikipedia.org/wiki/Nearest_neighbor_search" rel="external nofollow noreferrer">nearest neighbor search</a> problem. Given an app X, we want to find the k nearest apps. In the case of “you might also like”, a naive approach would be one based on counting, where if many people installed apps X and Y, then the app Y would be used as candidate for seed app X. However, this approach is intractable as it is difficult to learn and generalize effectively in the huge problem space. Given that there are over a million apps on Google Play, the total number of possible app pairs is over ~10<sup>12</sup>. </p>
<p>To solve this, we trained a deep neural network to predict the next app installed by the user given their previous installs. Output <a href="https://en.wikipedia.org/wiki/Embedding" rel="external nofollow noreferrer">embeddings</a> at the final layer of this deep neural network generally represents the types of apps a given user has installed. We then apply the nearest neighbor algorithm to find related apps for a given seed app in the trained embedding space. Thus, we perform dimensionality reduction by representing apps using embeddings to help prune the space of potential candidates.</p>
<p>Online Personalized Re-ranking<br />
The candidates generated in the previous step represent relatedness along multiple dimensions. The objective is to assign scores to the candidates so they can be re-ranked in a personalized way, in order to provide an experience that is crafted to the user’s overall interests and yet maintain relevance for the user installing a given app. In order to do this, we take the characteristics of the app candidates as input to a separate deep neural network, which is then trained with real-time with user specific context features (region, language, app store search queries, etc.) to predict the likelihood of a related app being specifically relevant to the user.<br />
<table>
<tbody>
<tr>
<td><a href="https://4.bp.blogspot.com/-MxUhl0cs0F0/WFGG_XIEdVI/AAAAAAAABdI/U7oEdWud80kdp258pAI8kN85niKE1SX4ACLcB/s1600/image00.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzLzQuYnAuYmxvZ3Nwb3QuY29tLy1NeFVobDBjczBGMC9XRkdHX1hJRWRWSS9BQUFBQUFBQUJkSS9VN29FZFd1ZDgwa2RwMjU4cEFJOGtOODVuaUtFMVNYNEFDTGNCL3M2NDAvaW1hZ2UwMC5wbmc=.jpg"></a></td>
</tr>
<tr>
<td>Architecture for personalized related apps</td>
</tr>
</tbody>
</table>
<p>One of the takeaways from this work is that re-ranking content, like related apps, is one of the critical ways of app discovery in the store, and can bring great value to the user without impacting perceived relevance. Compared to the control (where no re-ranking was done), we saw a 20% increase in the app install rate from the “You might also like” suggestions. This had no user perceivable change in latency.</p>
<p>In Part 3 of this series, we will discuss how we employ machine learning to keep bad actors who try to manipulate the signals we use for search and personalization at bay.</p>
<p>Acknowledgements<br />
This work was done within the Google Play team in collaboration with Halit Erdogan, Mark Taylor, Michael Watson, Huazhong Ning, Stan Bileschi, John Kraemer, and Chuan Yu Foo.</p>
<h2><a href="https://research.googleblog.com/2017/01/app-discovery-with-google-play-part-3.html" rel="external nofollow noreferrer">App Discovery with Google Play, Part 3: Machine Learning to Fight Spam and Abuse at Scale</a></h2>
<p>Monday, January 30, 2017</p>
<p>Posted by Hsu-Chieh Lee, Xing Chen, Software Engineers, and Qian An, Analyst</p>
<p><i>In <a href="https://research.googleblog.com/2016/11/app-discovery-with-google-play-part-1.html" rel="external nofollow noreferrer">Part 1</a> and <a href="https://research.googleblog.com/2016/12/app-discovery-with-google-play-part-2.html" rel="external nofollow noreferrer">Part 2</a> of this series on app discovery, we discussed using machine learning to gain a deeper understanding of the topics associated with an app, and a deep learning framework to provide personalized recommendations. In this post, we discuss a machine learning approach to fight spam and abuse on apps section of the Google Play Store, making it a safe and trusted app platform for more than a billion Android users. </i></p>
<p>With apps becoming an increasingly important part of people’s professional and personal lives, we realize that it is critical to make sure that 1) the apps found on Google Play are safe, and 2) the information presented to you about the apps is both authentic and unbiased. With more than 1 million apps in our catalog, and a significant number of new apps introduced everyday, we needed to develop scalable methods to identify bad actors accurately and swiftly. To tackle this problem, we take a two-pronged approach, both employing various machine learning techniques to help fight against spam and abuse at scale.</p>
<p>Identifying and blocking ‘bad’ apps from entering Google Play platform</p>
<p>As mentioned in <a href="https://play.google.com/about/developer-content-policy/" rel="external nofollow noreferrer">Google Play Developer Policy</a>, we don’t allow listing of malicious, offensive, or illegal apps. Despite such policy, there are always a small number of bad actors who attempt to publish apps that prey on users. Finding the apps that violate our policy among the vast app catalog is not a trivial problem, especially when there are tens of thousands of apps being submitted each day. This is why we embraced machine learning techniques in assessing policy violations and potential risks an app may pose to its potential users.</p>
<p>We use various techniques such as text analysis with word embedding with large probabilistic networks, image understanding with Google Brain, and static and dynamic analysis of the APK binary. These individual techniques are aimed to detect specific violations (e.g., restricted content, privacy and security, intellectual property, user deception), in a more systematic and reliable way compared to manual reviews. Apps that are flagged by our algorithms either gets sent back to the developers for addressing the detected issues, or are ‘quarantined’ until we can verify its safety and/or clears it of potential violations. Because of this app review process combining analyses by human experts and algorithms, developers can take necessary actions (e.g., iterate or publish) within a few hours of app submission.</p>
<table>
<tbody>
<tr>
<td><a href="https://3.bp.blogspot.com/-WpRAutHMDhg/WI-mH5grBUI/AAAAAAAABfw/LMW2Alp9FvENS-9-36yJ3dX7Z29BoybnwCLcB/s1600/image00.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzLzMuYnAuYmxvZ3Nwb3QuY29tLy1XcFJBdXRITURoZy9XSS1tSDVnckJVSS9BQUFBQUFBQUJmdy9MTVcyQWxwOUZ2RU5TLTktMzZ5SjNkWDdaMjlCb3libndDTGNCL3M2NDAvaW1hZ2UwMC5wbmc=.jpg"></a></td>
</tr>
<tr>
<td>Visualization of word embedding of samples of offensive content policy violating apps (red dots) and policy compliant apps (green dots), visualized with t-SNE (<a href="https://en.wikipedia.org/wiki/T-distributed_stochastic_neighbor_embedding" rel="external nofollow noreferrer">t-Distributed Stochastic Neighbor Embedding</a>).</td>
</tr>
</tbody>
</table>
<p>Preventing manipulation of app ratings and rankings </p>
<p>While an app may itself be legitimate, some bad actors may attempt to create fake engagements in order to manipulate an app’s ratings and rankings. In order to provide our users with an accurate reflection of the app’s perceived quality, we work to nullify these attempts. However, as we place countermeasures against these efforts, the actors behind the manipulation attempts change and adapt their behaviors to bypass our countermeasures thereby presenting us with an <a href="https://en.wikipedia.org/wiki/Adversarial_machine_learning" rel="external nofollow noreferrer">adversarial problem</a>.</p>
<p>As such, instead of using a conventional supervised learning approach (as we did in the ‘<a href="https://research.googleblog.com/2016/11/app-discovery-with-google-play-part-1.html" rel="external nofollow noreferrer">Part 1</a>’ or ‘<a href="https://research.googleblog.com/2016/12/app-discovery-with-google-play-part-2.html" rel="external nofollow noreferrer">Part 2</a>’ of this series, which are more ‘stationary’ problems), we needed to develop a repeatable process that allowed us the same (if not more) agility that bad actors have. We achieved this by using a hybrid strategy that utilizes <a href="https://en.wikipedia.org/wiki/Unsupervised_learning" rel="external nofollow noreferrer">unsupervised learning</a> techniques to generate training data which in turn feeds into a model built on traditional <a href="https://en.wikipedia.org/wiki/Supervised_learning" rel="external nofollow noreferrer">supervised learning</a> techniques. </p>
<p>Utilizing data on interactions, transactions, and behaviors occurring on the Google Play platform, we apply anomaly detection techniques to identify apps that are targeted by fake engagements. For example, a suspected app may have all its engagement originating from a single data center, whereas an app with organic engagement will have its engagement originating from a healthy distribution of sources.</p>
<p>We then use these apps to isolate actors who collude or orchestrate to manipulate ratings and rankings, who in turn are used as training data to build a model that identifies similar actors. This model, built using supervised learning techniques, is then used to expand coverage and nullify fake engagements across Google Play Apps platform.<br />
<table>
<tbody>
<tr>
<td><a href="https://3.bp.blogspot.com/-CgxcDq6mSnM/WI-kOGKaY_I/AAAAAAAABfg/djCvj_DHn3ci4D5QZnTTWvI3zoyxQIsmwCLcB/s1600/image01.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzLzMuYnAuYmxvZ3Nwb3QuY29tLy1DZ3hjRHE2bVNuTS9XSS1rT0dLYVlfSS9BQUFBQUFBQUJmZy9kakN2al9ESG4zY2k0RDVRWm5UVFd2STN6b3l4UUlzbXdDTGNCL3M2NDAvaW1hZ2UwMS5wbmc=.jpg"></a></td>
</tr>
<tr>
<td>A visualization of how a model trained on known bad actors (red) expands coverage to detect similar bad actors (orange) while ignoring organic users (blue).</td>
</tr>
</tbody>
</table>
<p>We strive to make Google Play the best platform for both developers and users, by enabling fast publication while not compromising user safety. The machine learning capabilities mentioned above helped us achieve both, and we’ll continue to innovate on these techniques to ensure we keep our users safe from spam and abuse.</p>
<p>Acknowledgements<br />
This work was done in close collaboration with Yang Zhang, Zhikun Wang, Gengxin Miao, Liam MacDermed, Dev Manuel, Daniel Peddity, Yi Li, Kazushi Nagayama, Sid Chahar, and Xinyu Cheng.</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 08:08:42</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%a0%96%e7%a4%be%e5%8c%ba/" title="云栖社区">云栖社区</a>, <a href="https://www.iamivan.net/tag/google/" title="google">google</a>, <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/network/" title="network">network</a>, <a href="https://www.iamivan.net/tag/app/" title="app">app</a>, <a href="https://www.iamivan.net/tag/machine/" title="Machine">Machine</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>App Discovery with Google Play的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq7ZQZz.html" rel="bookmark">Windows 10迎来第三方谷歌地图应用Maps App Discovery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				众所周知,Google向来不屑于为Windows平台带来某些类型的官方应用,谷歌地图就是其中一个具有代表性的例子.好消息是,仍然有一些第三方应用开发者在努力着,将Google服务整合到他们的应用之中.本文要为大家介绍的,就是一款像极了官方版本的Maps App Discovery.该应用允许用户方便直接从Windows 10桌面上调用谷歌地图,而无需先打开浏览器. 根据Windows Store上贴出的信息,Maps App Discovery借助Google Maps API,为Windows			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjLVyZp.html" rel="bookmark">Sina App Engine与Google App Engine区别对比</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				新浪推出了自己的云计算服务平台,和Google一样,都叫App Engine.根据NIST对于云计算的定义,Google App Engine属于PaaS平台型服务,那么它具体提供什么样的服务,新浪推出的Sina App Engine和Google的又有哪些区别呢? 背景 云计算服务在Google.Amazon等公司成功产品的引领下,正在商业化的道路上大步向前.在NIST的定义中,有三种云计算服务模型. Software as a Service (SaaS):软件即服务模型,用户直接使用构建在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJeNx8p.html" rel="bookmark">一个app上到Google play里是不是全球只有一个下载链接？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 一个app上到Google play里是不是全球只有一个下载链接? 我们知道Google play也是分国家地区的,那么如果一个app上到很多国家,是不是只有一个下载链接就可以自动跳转到对应的国家和地区 解决方案 没试过,你自己试试,看看不同的国家是不是一个连接不就好了? 解决方案二: &amp;hl=语言 这个是在同一个连接里面用传参方式来区分的国家,而且是用get方式 换句话说,这个&quot;语言&quot;就是hl的值,接口使用get方式接收,然后判断这个值是什么来区分是哪个国家, 所以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk5ynyb.html" rel="bookmark">应用收入方面App Store比Google Play高出130&percnt;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: 腾讯科技讯 (林靖东)北京时间 7月31日 消息,据国外媒体报道,据应用市场研究公司App Annie最新统计数据表明,Google Play已经在应用下载量上面超过了iOS App Store,但在应用收入方面, 腾讯科技讯(林靖东)北京时间7月31日消息,据国外媒体报道,据应用市场研究公司App Annie最新统计数据表明,Google Play已经在应用下载量上面超过了iOS App Store,但在应用收入方面,App Store仍然比Google Play高出130%. 现在,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDyA3vb.html" rel="bookmark">使用Google App Engine、Google Closure Library与Clojure编写HTML5应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上周,Freiheit.com的CTO Stefan Richter在慕尼黑举办的Google开发者日上谈到了他对于使用HTML 5与Google App Engine编写富Internet应用的愿景.特别地,他认为相对于基于服务器端的页面渲染来说,基于HTML 5来构建客户端组件会更加困难. 在之前的Web开发中,厚重的客户端应用模型都是基于Widget.事件以及事件处理器,这经常会导致复杂的事件处理链,而这一切会造成维护的 梦魇.在两层的客户端应用模型中,人们甚至会直接从事件处理器中访问数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze42gOp.html" rel="bookmark">如何自动登入google play下载app report</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				流程 1.登入google play 登入google play需要三步 https://play.google.com/apps/publish/ https://accounts.google.com/ServiceLogin?hl=en&amp;continue=https://play.google.com/apps/publish/ https://accounts.google.com/ServiceLoginAuth 2.下载app report zip 3.unzip report 代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5AewAp.html" rel="bookmark">在Google App Engine Java版上构建电子书分享网站</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介:&quot;云计算&quot;是目前热门的技术方向,本文从 Google 的云计算平台 App Engine 入手,简单介 绍了 Google 面向 Java 开发人员的云计算平台.从一个实际的电子书分享应用构建出发,讲述了如何在 Google App Engine 平台上构建这个应用程序. &quot;云计算&quot;基本概念的介绍 根据维基百科上的定义,云计算是一种动态易扩展,而且通常是通过互联网提供的虚拟化的资源计算 方式,用户不需要了解云内部的细节,也不必具有云内部的专业知识,或者直接控制			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDdmBz.html" rel="bookmark">Google 的 Web App &OpenCurlyDoubleQuote;复仇记&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				曾经有一段时间,随着HTML5的炒作走向高潮,与开发难度更高的原生app相比,移动web被认为是移动应用的明天.但随着原生app在速度和功能丰富程度上轻松胜出,移动web日渐消沉下去.不过最近随着技术的演进以及应用商店令人沮丧的体验,Google现在又携着经过改进的Progressive Web App卷土重来,试图向原生app发起复仇. 对于Google开发者Alex Russell来说,开发web app不仅仅只是工作,还是他的个人信仰. 自去年以来,Russell 就一直为一种新型的基于			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOJJDvp.html" rel="bookmark">新版 Google App Engine 支持所有编程语言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				App Engine 是 Google 的平台即服务 (Platform-as-a-Service PaaS) ,用于构建应用后端,而无需担心维护复杂的基础架构. Google 在博客上表示实现了最初的承诺,新版 Google App Engine 带来了更高的开放性和灵活性,支持所有编程语言.所有框架.所有的库.包括 Node.js.Ruby. Java 8. Python 2.7 &amp; 3.5.Go 1.8. Swift.Perl. Elixir. PHP 7.1 等等等等.新版本还带来了对			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRwQxp.html" rel="bookmark" class="title">win8键盘快捷键大全</a>
					<div>
						windows 8用户体验版本一经发布,就有上亿电脑爱好者纷纷下载安装体验,不过windows 8操作系统增加了不少新功能,对系统界面设计也改进了很多,尤其是增加了专为触屏电脑设计的Metro界面,令 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrXg6z.html" rel="bookmark" class="title">imestamp-Date或子类的输出格式（要求类型不能变）</a>
					<div>
						问题描述 Date或子类的输出格式(要求类型不能变) 比如Person的成员变量 java.util.Date createTime; 现在想要System.out.println(person.ge ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPv9lb.html" rel="bookmark" class="title">使用Photoshop CS2轻松创建全景相片</a>
					<div>
						创建 在生活或工作中,我们有时会用到全景相片,比如在拍摄大型的合影照片,或者某些工厂中比较长的生产线时,就需要全景相片来表现比较广阔的画面.但是,由于受我们的相机镜头限制,所拍摄的画面宽度或高度并不能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWYdqz.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;IT民工&rdquo;的归属感和认同感</a>
					<div>
						前几天和一个网友聊天,我问他你干什么工作的?他说,工人.他说,你呢?我以为他是瞎忽悠我的,我说,农民.他说,农民挺好.我说,现在不种地,进城打工,成民工了. 这是一段瞎扯的话,不过,这让我想起了民工. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkWjjp.html" rel="bookmark" class="title">2013 做SEO应该了解这些</a>
					<div>
						春节假期终于结束,给大家拜个晚年,余斗休息长达半个月,终于来上班了,激动不已,在家中休息的半个月,余斗也思考了关于SEO的一些处境,对于2012年的SEO行业,余斗认为是动荡比较大的一年.虽然余斗也是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxP5wRM.html" rel="bookmark" class="title">oracle&plus;jsp中blob类型存储大文本问题解决方法</a>
					<div>
						oracle 存储大文本一直是一个棘手的问题. 一.存数据库: &lt;%@page contentType=&quot;text/html; charset=gb2312&quot; languag ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwZR3z.html" rel="bookmark" class="title">解决Word表格粘贴时错位难题</a>
					<div>
						Word中处理个人简历表格时,经常要遇到将一个表格的某些行复制到另一个表格的情形.看起来很简单的一个问题,却常常会出现意外的结果--即使两个表格的列数完全一样,粘贴结果却经常&quot;错位&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKxZWp.html" rel="bookmark" class="title">linux shell环境以及shell脚本</a>
					<div>
						  1.&quot;&quot; '' ``的区别,&quot;&quot;中的变量会被解析 ''中所有的都被当成字符串 ``执行系统命令 2.自定义的变量默认是局部变量,环境变量是全局变量. 3.e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3KnmM.html" rel="bookmark" class="title">WIN7版本查看图解</a>
					<div>
						现在用WIN7的越来越多了,WIN7版本也很多,一共包含6个版本:分别为Windows 7 Starter(初级版).Windows 7 Home Basic(家庭普通版).Windows 7 Hom ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGVD1b.html" rel="bookmark" class="title">Win8&period;1使用技巧之电源模式管理优化指南</a>
					<div>
						电源优化管理有何优点? 电源管理的优化,能维护电脑稳定运行,降低设备各部件功耗,节省用电开销,延长设备电池及各部件的使用寿命,使设备能够长久保持稳定.低能耗.高性能的运 行状态.由于以往的Window ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8reeb.html" rel="bookmark" class="title">WindowsXP系统怎样进行颜色校准的方法</a>
					<div>
						  WindowsXP系统怎样进行颜色校准的方法          具体方法如下: 1.以AMD显卡为例,首先右击桌面空白处选择&quot;Catalyst(TM) Control Center&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBK0n4M.html" rel="bookmark" class="title">win7 64位旗舰版AHCI功能开启能够提高硬盘性能吗</a>
					<div>
						  使用Windows7操作系统的用户都会知道很多数据,我们都是在注册表编辑器中修改完成的.什么是AHCI?AHCI是指串行在ATA高级主控接口的意思,宽的功能是允许存储驱动程序启用高级SATA功能. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXPnGp.html" rel="bookmark" class="title">笔记本电脑怎么连接投影仪？</a>
					<div>
						  在大学多媒体教程以及办公会议场等所我们经常会看到笔记本连接投影仪配合使用,通过将笔记本的画面投放到超大投影仪画布上.那么笔记本怎么连接投影仪?相信很多朋友都没有接触过,以下小编将为大家详细介绍下笔 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badj5qz.html" rel="bookmark" class="title">readonly和disabled属性的区别&lowbar;基础知识</a>
					<div>
						标签的readonly和disabled属性的区别: 在表单元素中,readonly和disable有类似之处,因为它们都可以将一些表单元素设置为&quot;不可用&quot;状态,当然它们之间的区别 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrWRVM.html" rel="bookmark" class="title">ORA-19502&colon; write error on file &amp;quot&semi;xxxxx&amp;quot&semi;&comma; block number xxxx</a>
					<div>
						错误现象: 在ORACLE 10g下为表空间IGNITE_EGVSQL01增加数据文件时,报如下错误: SQL&gt; ALTER TABLESPACE IGNITE_EGVSQL01      AD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrqYVM.html" rel="bookmark" class="title">dojo在ASP&period;NET中使用Ajax初步</a>
					<div>
						我想先介绍一下dojo中的浏览器事件,由于不同的浏览器对dom事件的支持是不同的,dojo在这方面做了统一的封装,所以使用dojo不用担心浏览器事件不兼容的问题.问题也就由此而来,由于要兼容不同的浏览 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOl8vQb.html" rel="bookmark" class="title">DB-Engines最新11月数据库排名：MariaDB助力，MySQL流行度超越Oracle</a>
					<div>
						在 DB-Engines 的最新11月排名中,MySQL 和 Oracle 已经相差无几,这得益于2017年10月MySQL的增长强劲,可是要知道MySQL的另外一个重要分支,MariaDB已然跃升至 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAGK2M.html" rel="bookmark" class="title">分布式锁的实现</a>
					<div>
						1 分布式锁的疑问 谈到分布式锁,有很多实现方式,如数据库.redis.ZooKeeper等.提个问题: 实现分布式锁需要满足哪些条件呢? 2 数据库实现分布式锁 2.1 实现案例 如使用数据库事务中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqAJWz.html" rel="bookmark" class="title">有人使用coq软件的吗&quest;急&excl;急&excl;急&excl;</a>
					<div>
						问题描述 coq是一种形式化分析工具,急问! 解决方案 解决方案二:有.........但是你到底想问啥问题?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeROljb.html" rel="bookmark" class="title">平台经济下如何更好地保护消费者权益？</a>
					<div>
						互联网在给人们带来便利.快捷.高效的电子商务同时,其全球性.虚拟性和管理 的非中心化等特点也给消费者带来了各种风险. 同时,电子商务的高速发展,海量数据与个性化,对治理的快速响应要求,多样性.生态化与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoP0VM.html" rel="bookmark" class="title">苹果库克 思科钱伯斯 三星李健熙 任正非还要干掉多少跨国企业CEO？</a>
					<div>
						现在跨国企业对华为充满恐惧,只要与华为在业务上出现交集,那华为肯定就是它的噩梦. 所以,在跨国企业高层圈,这样的一种共识正在弥漫:与华为业务上没有交集是值得庆幸的;成为华为的竞争对手则是不幸的. 这种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR06Ap.html" rel="bookmark" class="title">全天下最经典的句子，2013重现&excl;</a>
					<div>
						那些最终会让你陷进去的,一开始总是美好. 当你做对的时候,没有人会记得:当你做错的时候,连呼吸都是错. 等待,是一生最初的苍老. 祈求天地放过一双恋人,怕发生的永远别发生. 有些事一转身就一辈子. 年 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baB39nM.html" rel="bookmark" class="title">web服务-Azure中部署网站，如何使用不同的用户名，不想使用同一个用户</a>
					<div>
						问题描述 Azure中部署网站,如何使用不同的用户名,不想使用同一个用户 在Azure中部署web服务,默认情况下都是使用同一个用户名,即使是不同的订阅,不同的web服务.怎么才能做到一个web服务拥 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg88OM.html" rel="bookmark" class="title">maven  dependencie-maven项目下的依赖吗maven dependencie老是丢失</a>
					<div>
						问题描述 maven项目下的依赖吗maven dependencie老是丢失 丢失后删掉项目下的那.setting .classpath .project 然后重新用svn服务器上更新,又有了,怎么回 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYP1rb.html" rel="bookmark" class="title">javascript全局变量封装模块实现代码&lowbar;javascript技巧</a>
					<div>
						下面的代码是我的测试代码,注释很重要: 复制代码 代码如下: /*global window,jQuery,validate_email,masterUI,$,rest*/ /** Enable EC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0yR7p.html" rel="bookmark" class="title">Javascript----文件操作&lowbar;javascript技巧</a>
					<div>
						Javascript----文件操作 一.功能实现核心:FileSystemObject 对象    要在javascript中实现文件操作功能,主要就是依靠FileSystemobject对象. 二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Z023z.html" rel="bookmark" class="title">【转】常见hibernate面试题（转载）</a>
					<div>
						1.Hibernate有哪几种查询数据的方式 (1)导航对象图查询 (2)OID查询 (3)HQL (4)QBC (5)本地SQL 2.load()和get()的区别 load加载方法: Java代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqW4KGz.html" rel="bookmark" class="title">sql数据显示问题，快崩溃了！</a>
					<div>
						问题描述 SQL2000数据库表中有一数据int类型的数值为33每运行一次程序,对应数值-1,.运行1次:程序中查数据库值-----32运行2次:程序中查数据库值-----31运行3次:程序中查数据库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqV7Wp.html" rel="bookmark" class="title">JQuery运动特效</a>
					<div>
						       JQuery作为一个强大的JS框架,为我们在实际中避免了很多问题,比如,不会写算法,总得做浏览器的兼容等等.最近用到了JQuery的一些特效,拿出来复习下.      常见特效 Fade ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlRGvp.html" rel="bookmark" class="title">交钱就上任何学校&OpenCurlyDoubleQuote;点招&rdquo;沦为高考招生一大毒瘤</a>
					<div>
						高考&quot;点招&quot;横行(资料图片) 中广网北京7月21日消息 据中国之声&lt;新闻晚高峰&gt;报道,随着高考录取工作的进行,不少孩子已经在欣喜地等待着录取通知书的到来.可还有一些孩子 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
